#! /usr/local/bin/ruby -Ks

=begin
pOtԍXNvgpHTMLNX
2002.6.8 Cyross Makoto
=end

$KCODE = "SJIS"

require "jcode"
require "kconv"
require "labelclass"

=begin

CHTML
HTMLNX

=end

class CHTML

	@@ishtml = false
	@@n_tag_s = ""
	@@n_tag_e = ""
	@@m_tag_s = ""
	@@m_tag_e = ""
	@@b_tag_s = ""
	@@b_tag_e = ""
	@@keta = 0;
	@@txtcl = ""
	@@bgcl = ""
	@@bgimage = ""
	@@bodybold = false
	@@opdir = "./"
	@@gbtitle = ""
	@@keyword = Array.new
	
=begin

CHTML.new
IuWFNg̏

=end

	def initialize(keta)
		if @@keta == 0 then
			@@keta = keta;
		end
	end
	
=begin

CHTML.set(datafilename, keywordfilename)
HTMLIuWFNgɃf[^A^O
L[[h擾

=end
	
	def set(datafilename, keywordfilename)
		s = ""
		File.open(datafilename, "r"){|f|
			s = f.gets
			@@opdir = s.chomp
			s = f.gets
			@@txtcl = s.chomp
			s = f.gets
			@@bgcl = s.chomp
			s = f.gets
			if s.chomp == "True" then
				bodybold = true
			end
			s = f.gets
			@@bkimage = s.chomp.tr("\\","/")
			@@n_tag_s, @@n_tag_e = maketag(f)
			@@m_tag_s, @@m_tag_e = maketag(f)
			@@b_tag_s, @@b_tag_e = maketag(f)
		}

		File.open(keywordfilename, "r"){|f|
			while(f.gets) do
				line = $_.chomp
				if line.tr(" ","") != "" then
					@@keyword.push(line)
				end
			end
		}
	end
	
=begin

CHTML.maketag(f)
xENEpHTML^O쐬

=end

	def maketag(f)
		st = ""
		ed = ""
		s = f.gets
		if s.chomp == "True" then
			st = "<B>" + st
			ed = ed + "</B>"
		end
		s = f.gets
		if s.chomp == "True" then
			st = "<I>" + st
			ed = ed + "</I>"
		end
		ed = ed + "</FONT>"
		t = ""
		s = f.gets
		n = s.chomp.to_i
		case n
		when 0..2
			t = "<FONT SIZE=\"-"+(3-n).to_s+"\" "
		when 4..7
			t = "<FONT SIZE=\"+"+(n-3).to_s+"\" "
		else
			t = "<FONT "
		end
		s = f.gets
		t = t + "COLOR=\""+s.chomp.sub(/#/,"\\<SHP>")+"\">"
		st = t + st
		[st, ed]
	end


=begin

CHTML.canuse
HTMLIuWFNggp\ɂȂ

=end

	
	def canuse
		@@ishtml = true
	end
	
	
=begin

CHTML.sethtmlpreface(fw, title, title2)
HTMLo͂ǂ𖾎

=end

	def ishtml?
		@@ishtml
	end

=begin

CHTML.setgbtitle(constlist)
萔GBTitle萔΂擾

=end
	
	def setgbtitle(constlist)
		if constlist["GBTitle"] != "" then
			@@gbtitle = constlist["GBTitle"]
		end
	end
	
=begin

CHTML.sethtmlpreface(fw, title, title2)
HTMLt@C̃wbh쐬

=end

	def sethtmlpreface(fw, title, title2)
		if not (@@ishtml) then
			return
		end
		fw.puts("<HTML>\n")
		fw.puts("<HEAD>\n")
		if @@gbtitle != "" then
			fw.puts("<TITLE>"+@@gbtitle + ":" + title2+"</TITLE>\n")
		else
			fw.puts("<TITLE>"+title2+"</TITLE>\n")
		end
		fw.puts(insertJumpJs)
		fw.puts("</HEAD>\n")
		fw.puts("<BODY TEXT=\""+@@txtcl+"\" BGCOLOR=\""+@@bgcl+"\" BACKGROUND=\"./image/"+@@bkimage+"\">\n")
		if @@bodybold == true then
			fw.puts("<B>\n")
		end
		t = changeMacro(@@n_tag_s + title + @@n_tag_e)
		fw.puts( t + "<BR>\n")
		fw.puts("<HR><BR>\n")
	end
	
=begin

CHTML.sethtmlpostface(fw)
HTMLt@C̃tbg쐬

=end

	def sethtmlpostface(fw)
		if not (@@ishtml) then
			return
		end
		if @@bodybold then
			fw.puts("</B>\n")
		end
		fw.puts("<BR><HR>\n")
		fw.puts("</BODY>\n</HTML>\n")
	end

=begin

CHTML.setParagraph(list, labellist)
xɃpOtԍ𖄂ߍ

=end

	def setParagraph(list, llist)
		nowlabel = ""
		nlist = Array.new
		list.each{|line|
			if line =~ /^:/ then
				nowlabel = $'.chomp
			end
			while line =~ /#([^#]+)#/ do
				label = $1.strip
				if(llist.index(label)==-1) then
					warning(1, "̃x͎Qƌɂ܂B:"+label)
					break
				else
					pnum = llist.getPnum(label)
					if @@ishtml then
						line = line.sub(/#[^#]+#/,makeLingTag(pnum, pnum.to_s))
					else
						line = line.sub(/#[^#]+#/, pnum.to_s)
					end
					llist.refInc(label)
				end
			end
			line = setMacro(line)
			line = replaceInput(line, llist, nowlabel)
			if @@ishtml then
				@@keyword.each{|kw|
					kwr = Regexp::new(kw)
					tline = ""
					while kwr.match(line) do
						tline = $` + @@b_tag_s + $& + @@b_tag_e
						line = $'
					end
					line = tline + line
				}
			end
			line = changeMacro(line)
			nlist.push(line)
		}
		nlist
	end

	def setMacro(line)
		while line =~ /\\<B:([^>]+)>/ do
			if @@ishtml then
				line = line.sub(/\\<B:[^>]+>/, @@b_tag_s + $1.strip + @@b_tag_e)
			else
				line = line.sub(/\\<B:[^>]+>/, $1.strip)
			end
		end
		while line =~ /\\<IMG:([^>]+)>/ do
			if @@ishtml then
				line = line.sub(/\\<IMG:[^>]+>/, "<IMG SRC=\"./image/"+ $1 +"\">")
			else
				line = line.sub(/\\<IMG:[^>]+>/, "")
			end
		end
		line
	end
	

=begin

changeMacro(s)
}NLɒu

=end

	def changeMacro(line)
		s1 = line.gsub(/\\<SHP>/, "#")
		s1 = s1.gsub(/\\<COLON>/, ":")
		s1 = s1.gsub(/\\<YEN>/, "\\")
		s1 = s1.gsub(/\\<DOLLER>/, "$")
		s1
	end
	
=begin

replaceInput(str)
\<INPUT:`>ꍇ͓̓tH[ݒ肷

=end

	def replaceInput(line, llist, label)
		while line =~ /\\<INPUT:([^>]+)>/ do
			if llist.inputUse?(label) then
				error(9, "pOtɂQȏ̓̓^O܂B")
				exit
			end
			if @@ishtml then
				pnumlist = $1.strip
				llist.inputUse(label, pnumlist)
				line = line.sub(/\\<INPUT:[^>]+>/, @@b_tag_s + "i̓̓{bNXɃpOtԍ͂āuIv{^Ăj" + @@b_tag_e)
				print "oOtԍ#{llist.getPnum(label)}ɃpOtԍ̓tH[}܂B\n"
			else
				line = line.sub(/\\<INPUT:[^>]+>/, "")
			end
		end
		line
	end
	
=begin

makeLingTag(number, text)
ΏۃpOtԍւ̃N^O쐬

=end

	def makeLingTag(number, text)
		"<A HREF=\"./"+format("%0#{@@keta}d",number)+".html\">" + @@m_tag_s + text + @@m_tag_e + "</A>"
	end

	def output(list, llist, fname)
		if @@ishtml then
			output_html(list, llist)
		else
			File.open(fname,"w"){|fw|
				output_text(fw, list, llist)
			}
		end
	end

	def output_text(fw, list, llist)
		# pOt͂̕Rs[(eLXgo)
		llist.each_by_pnum{|l|
			fw.puts("#{l.getPnum}\n")
			fr, ln = l.getLines
			ln.times{|i|
				fw.puts(list[fr+i + 1])
			}
		}
	end
	
	def output_html(list, llist)
		# pOt͂̕Rs[
		flag = 0
		llist.each{|l|
			pnum = l.getPnum
			fr, ln = l.getLines
			fname = @@opdir+"\\"+format("%0#{@@keta}d",pnum)+".html"
			File.open(fname,"w"){|fw|
				sethtmlpreface(fw, pnum.to_s, "pOt"+pnum.to_s)
				ln.times{|i|
					fw.puts(list[fr+i+1] + "<BR>\n")
				}
				if l.inputUse? then
					fw.puts(insertJumpForm(l.getInputList))
				end
				sethtmlpostface(fw)
			}
		}
	end
	
=begin

insertJumpJs
͂JavaScriptt@Cɖߍ

=end

	def insertJumpJs
		"<META HTTP-EQUIV=\"Content-Script-Type\" CONTENT=\"text/javascript\">\n" +
		"<SCRIPT TYPE=\"text/javascript\">\n" +
		"<!--\n" +
		"function jump(){\n" +
		"	if(document.inputf.num.value != null){\n" +
		"		vstr = document.inputf.num.value;\n" +
		"		if(isNaN(parseInt(vstr, 10))){\n" +
		"			alert(\"p͂ĂB\");\n" +
		"			self.location.reload(true);\n" +
		"		}\n" +
		"		else{\n" +
		"			zerolen = #{@@keta} - vstr.length;\n" +
		"			if(zerolen < 0){\n" +
		"				alert(\"l#{@@keta}܂łłB\");\n" +
		"				self.location.reload(true);\n" +
		"			}\n" +
		"			nlist = document.inputf.pglist.value.split(\",\");\n" +
		"			matched = false;\n" +
		"			for(i = 0; i < nlist.length; i++){\n" +
		"				if(parseInt(vstr) == parseInt(nlist[i])){\n" +
		"					matched = true; \n" +
		"					fname = \"\";\n" +
		"					for(i = 0; i < zerolen; i++){\n" +
		"						fname = fname + \"0\";\n" +
		"					}\n" +
		"					fname = fname + vstr + \".html\";\n" +
		"					self.location.href = fname;\n" +
		"				}\n" +
		"			}\n" +
		"			if(matched == false){\n" +
		"				alert(vstr + \"͐̃pOtԍȂłˁB\");\n" +
		"				self.location.reload(true);\n" +
		"			}\n" +
		"		}\n" +
		"	}\n" +
		"}\n" +
		"-->\n" +
		"</SCRIPT>\n"
	end

=begin

insertJumpForm(plist)
̓tH[t@Cɖߍ

=end

	def insertJumpForm(plist)
		"<BR><BR>\n" +
		"<FORM NAME=\"inputf\">\n" +
		"<INPUT TYPE=\"hidden\" NAME=\"pglist\" VALUE=\"#{plist}\">\n" +
		"<INPUT TYPE=\"text\" NAME=\"num\" VALUE=\"\" MAXLENGTH=\"#{@keta}\">\n" +
		"<INPUT TYPE=\"button\" VALUE=\"I\" onClick=\"jump()\">\n" +
		"</FORM>\n"
	end

end
