#! /usr/local/bin/ruby -Ks

=begin
pOtԍXNvgpxNX
2002.6.8 Cyross Makoto
=end

$KCODE = "SJIS"

require "jcode"
require "kconv"

=begin

CLabelManage
xǗNX

=end

class CLabelManage
	@@max = 0
	@@next = 0
	
	def initialize(n)
		if @@max == 0 then
			@@max = n
		end
		@labellist = Array.new(@@max)
		@@max.times{|i|
			@labellist[i] = CLabel.new
		}
		@labelhash = Hash.new(-1)
		@firstlabel = ""
		@lastlabel = ""
	end
	
	def insert(labelname)
		if not searchPre(labelname) then
			@labellist[@@next].setLabel(labelname, false)
			@labelhash[labelname] = @@next
			@@next = @@next + 1
		end
	end
	
	def max
		@@max
	end
	
=begin

CLabelManage.getLabel(list)
xNX쐬

=end
	
	def getLabel(list)
		fr = 0
		ln = 0
		ls = 0
		i = 0
		prelabel = ""
		list.each{|line|
			if line =~ /^:/ then
				label = $'.chomp.strip
				if ls > 0 then
					@labellist[index(prelabel)].setLines(fr, ln)
				end
				insert(label)
				if ls == 0 then
					@firstlabel = label
				end
				@lastlabel = label
				prelabel = label
				fr = i
				ln = 0
				ls = ls + 1
			else
				ln = ln + 1
			end
			i = i + 1
		}
		@labellist[index(@lastlabel)].setLines(fr, ln)
		setLast(@lastlabel)
	end
	
=begin

CLabelManage.setParagraphNum(list, last)
exɃpOtԍU

=end
	
	def makeParagraphNum(list, multi)
		@labellist[index(@firstlabel)].setPnum(1)
		left = 2
		
		if(multi == 0) then
			@labellist[index(@lastlabe)].setPnum(@@max)
		else
			left = 1
		end
		
		if(@@max > left) then
			(@@max-left).times{|i|
				if isPre?(i + 2) then
					next
				end
				ppnum = 0
				while(ppnum == 0) do
					rn = rand(@@max)
					if(@labellist[rn].getPnum==0) then
						@labellist[rn].setPnum(i + 2)
						ppnum = rn
					end
				end
			}
		end
	end
	
=begin

CLabelManage.makePreLabel(filename)
xNX쐬

=end
	
	def makePreLabel(filename, multi)
		File.open(filename, "r"){|f1|
			while(f1.gets) do
				$_ =~ /(.+)=(\d+)/
				lname = $1.strip
				lnum = $2.strip
				if (multi == 1) and (lnum.to_i == @@max) then
					error(2, "x̃pOtԍɍŌ̃pOtԍ͎gpł܂")
				end
				if lnum.to_i == 1 then
					error(2, "x̃pOtԍɂP͎gpł܂")
				end
				if lnum.to_i > @@max then
					error(2, "x#{lname}̃pOtԍ(#{lnum})Q[ubNŜ̃pOt(#{@@max})𒴂Ă܂I")
				end
				@labellist[@@next].setLabel(lname, true)
				@labellist[@@next].setPnum(lnum.to_i)
				@labelhash[lname] = @@next
				print "pOtԍF["+lname+"]="+lnum+"\n"
				@@next = @@next + 1
			end
		}
	end
	
	def searchPre(label)
		@labellist[index(label)].isPre?
	end
	
	def searchByName(label)
		@labellist[index(label)].getPnum
	end
	
	def searchByNum(number)
		name = ""
		@labellist.each{|l|
			if l.getPnum == number then
				name = l.getLname
			end
		}
		return name
	end

	def getdatByPnum(number)
		dat = nil
		@labellist.each{|l|
			if l.getPnum == number then
				dat = l
			end
		}
		return dat
	end

	def isPre?(number)
		pre = false
		@labellist.each{|l|
			if l.getPnum == number then
				pre = l.isPre?
			end
		}
		pre
	end

	def setLast(label)
		@labellist[index(label)].setLast
	end
	
	def index(label)
		@labelhash[label]
	end
	
	def refInc(label)
		@labellist[index(label)].refInc
	end
	
	def getPnum(label)
		@labellist[index(label)].getPnum
	end
	
	def inputUse(label, list)
		@labellist[index(label)].inputUse(list)
	end
	
	def inputUse?(label)
		@labellist[index(label)].inputUse?
	end
	
	def setFirstParagraph
		@labellist[index(label)].setFirst
	end
	
	def each
		@labellist.each{|l|
			if block_given? then
				yield(l)
			else
				l.getLname
			end
		}
	end
	
	def each_by_pnum
		@@max.times{|i|
			ldat = getdatByPnum(i+1)
			if block_given? then
				yield(ldat)
			else
				ldat.getLname
			end
		}
	end
	
=begin

CLabelManage.printLog(filename)
xƃpOtԍƂ̑Ή\t@Cɏo͂

=end
	
	def printLog(filename)
		File.open(filename, "w"){|f|
			@labellist.each{|l|
				print l.getLname+"="+l.getPnum.to_s+"/"
				f.puts(l.getLname+"  "+format("%5d",l.getPnum)+"\n")
			}
			print "\n"
		}
		print "pOtԍƃxƂ̑Ή\ #{filename} ɏo͂܂B\n"
	end

	def checkRefed
		@labellist.each{|l|
			if not l.isRef? then
				warning(2,"xQƂĂ܂B:"+l.getLname)
			end
		}
	end

	
=begin

warning(num, msg)
error(num, msg)
xEG[\

=end

	def warning(num, msg)
		print ">>>Worning("+num.to_s+"):"+msg+"\n"
	end
	
	def error(num, msg)
		print ">>>Error("+num.to_s+"):"+msg+"\n"
		exit(0)
	end

end


=begin

CLabel
xNX

=end

class CLabel
	def initialize
		@lname = ""
		@pnum = 0
		@pre = false
		@refnum = 0
		@last = false
		@from = 0
		@lines = 0
		@useinput = false
		@inputlist = ""
	end
	
	def setLabel(labelname, pre)
		@lname = labelname
		@pre = pre
		if @pre then
			@refnum = 1
		end
	end
	
	def setLines(fr, ln)
		@from = fr
		@lines = ln
	end
	
	def getLines
		[@from, @lines]
	end
	
	def setPnum(number)
		@pnum = number
	end
	
	def getLname
		@lname
	end
	
	def getPnum
		@pnum
	end
	
	def setLast
		@last = true
	end
	
	def isPre?
		@pre
	end
	
	def isLast?
		@last
	end
	
	def refInc
		@refnum = @refnum + 1
	end
	
	def isRef?
		f = false
		if @refnum > 0 then
			f = true
		end
		f
	end
	
	def inputUse(list)
		@inputlist = list
		@useinput = true
	end
	
	def inputUse?
		@useinput
	end
	
	def getInputList
		@inputlist
	end
	
end

